require "active_model"
require "active_support/core_ext/hash"

module GuidedPath
  class LeadInNode < Node
    
    attr_reader :text, :pause

    def initialize(args = {})
      super
      args = args.symbolize_keys

      raise(ArgumentError, "Must specify a value for the node") unless args[:text]
      @text = args[:text].to_s
      @pause = args[:pause].to_s
    end


    def to_hash
      output = super
      output[:type] = 'leadin'
      output[:text] = @text
      output[:pause] = @pause
      output
    end
    
  end
end
