require "active_model"

module GuidedPath
  class Node
    attr_accessor :label
    attr_reader :next_node

    def initialize(args = {})

      raise(ArgumentError, "Options must be a hash") unless args.kind_of?(Hash)
      args = args.symbolize_keys
      @label = args[:label]

      @next_node = (args[:next_node] || args[:goto])
      @next_node = @next_node.to_s.strip if @next_node

    end

    def next_node=(value)
      @next_node = value
    end

    def to_hash
      output = {}
      if @next_node
        output[:next_node] = @next_node.respond_to?(:label) ? @next_node.label : @next_node.to_s
      end

      output 
    end

  end
end
