require "active_model"
require "active_support/core_ext/hash"

module GuidedPath
  class QuestionMultipleChoiceNode < Node
    
    attr_reader :text, :answers

    def initialize(args = {})
      super
      args = args.symbolize_keys
      
      @answers = args[:answers] 
      raise(ArgumentError, "Must specify answers in an Hash") unless args[:answers] && args[:answers].kind_of?(Hash)
      @text = args[:text]
    end


    def to_hash
      output = super
      output[:type] = 'question_multiple_choice'
      output[:answers] = Hash[@answers.collect { |answer,node| [answer, node.label] }]
      output[:text] = @text
      return output
    end
    
  end
end
