require "active_model"
require "active_support/core_ext/hash"

module GuidedPath
  class TextNode < Node
    
    attr_reader :value

    def initialize(args = {})
      super
      args = args.symbolize_keys

      raise(ArgumentError, "Must specify a value for the node") unless args[:value]
      @value = args[:value].to_s
    end


    def to_hash
      output = super
      output[:type] = 'text'
      output[:value] = @value
      output
    end
    
  end
end
